

#    experiment run control for PGRIS - taken from sys.tcl

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0



variable Options

variable Supported_Modules {}


   proc load_Options {} {LoadOptions}
   proc update_Options {} {SaveOptions}

   proc Set_Options {} {
      variable Options
      variable Supported_Modules

      load_Options

      if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 150}
      if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 150}
      if {![info exists Options(Stat.shift)]} {set Options(Stat.shift) 6}
      if {![info exists Options(Stat.offset)]} {set Options(Stat.offset) 64}

      foreach module $Supported_Modules {
         set Options(Include.$module)  1
         set Options(Histogram.$module) 1
      }

      update_Options
   }

   proc Dump_Raw_Data {} {
      variable Supported_Modules

      set info ""

      foreach module $Supported_Modules {append info [Dump_Raw_[set module]_Data]}

      return $info
   }

   proc Stop_Electronics {} {
       variable Options 
       variable Supported_Modules

       foreach m $Supported_Modules {[set m]_DAQ-halt}

   }

   proc Go_Electronics {} {
      variable Options 
      variable Supported_Modules

       foreach m $Supported_Modules {[set m]_DAQ-go}
   }
 
   proc Reset_Electronics {} {    ;#   used by RESET
      variable Supported_Modules

      foreach m $Supported_Modules {[set m]_DAQ-reset}
   }

   proc Setup_Electronics {} {    ;#   used by SETUP
       variable Supported_Modules

       foreach m $Supported_Modules {[set m]_DAQ-setup}

   }

    proc TerminateExec {} {

        unmap_spectra
        DataAcqCommand 22 "Terminating DataAcq program" 0 2

    }

    proc LoadExec {} {

       set z [catch {eval exec nice [file join /MIDAS Data_Acq bin Linux64 PGRISExec$V4] &} m]
       if {$z != 0} {puts "RunControl LoadExec returned z=$z and $m"}

    }                                            

    foreach module $Supported_Modules {

        set f [file join $env(MIDASBASE) TclHttpd Html PGRIS RunControl sys.$module.tcl]
        set z [catch {source $f} m]
        if {$z == 0} {puts "RunControl loaded $f"} else {puts "RunControl returned z=$z and $m"}
    }

    make-UIregisters

    Set_Options

    foreach module $Supported_Modules {Set_[set module]_Options}
